<?php 


/*
	WPB Woocommerce Product Slider pro 
	By WPBean
	
*/

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly 


/**
 * Generated shortcode list
 */

function wpb_wps_get_shortcodes_list(){
	$output = array( __( 'Select a shortcode', 'wpb-woocommerce-product-slider' ) => '' );
	$args = array(
		'posts_per_page'   => -1,
		'post_type'        => 'wpb_wps_shortcode',
		'post_status'      => 'publish',
	);

	$posts = get_posts( $args );

	foreach ( $posts as $post ) {
		$output[$post->post_title] = $post->ID;
	}

	return $output;
}



if ( ! class_exists( 'wpb_wps_vc_elements_class' ) ) {

	/**
	 * Logo slider VC element Class
	 *
	 * @since	1.0
	 */
	class wpb_wps_vc_elements_class {


		public $wpbean = 'wpb-woocommerce-product-slider'; // textdomain for the plugin


		/**
		 * Constructor, checks for Visual Composer and defines hooks
		 *
		 * @since	1.0
		 */
		function __construct() {
            add_action( 'after_setup_theme', array( $this, 'wpb_wps_init' ), 1 );
		}

        public function wpb_wps_init() {
            if ( ! defined( 'WPB_VC_VERSION' ) ) {
                return;
            }
            if ( version_compare( WPB_VC_VERSION, '4.2', '<' ) ) {
        		add_action( 'after_setup_theme', array( $this, 'wpb_wps_vc_element' ) );
            } else {
        		add_action( 'vc_before_init', array( $this, 'wpb_wps_vc_element' ) );
            }
        }



		public function wpb_wps_vc_element() {
			// Check if Visual Composer is installed
			if ( ! defined( 'WPB_VC_VERSION' ) || ! function_exists( 'vc_add_param' ) ) {
				return;
			}


			vc_map( array(				
				'name' => __( 'Products slider', $this->wpbean ),
				'base' => 'wpb-product-slider-shortcode',
				'icon' => 'wpb_wps_icon',
				"class"	=> '',
				'description' => __( 'WPB WooCommerce Products slider.', $this->wpbean ),
			    "params" => array(
				
					array(
						'type' 			=> 'dropdown',
						'heading' 		=> __( 'Shortcode', $this->wpbean ),
						'param_name' 	=> 'id',
						'value'			=> wpb_wps_get_shortcodes_list(),
						'description' 	=> __( 'Choose a shortcode. Go to shortcode generator for adding a new shortcode.', $this->wpbean ),
						'admin_label' 	=> true,
					)
					
			    ),
			) );
		}

	}

	new wpb_wps_vc_elements_class();
}