<?php

/*
	WPB Woocommerce Product Slider pro 
	By WPBean
	
*/

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly 


/* ==========================================================================
   Adding modernizr
   ========================================================================== */

function wpb_wps_modernizr() {
	wp_enqueue_script('modernizr'); // deregister
	wp_enqueue_script( 'wpb_wps_modernizr', plugins_url('../js/modernizr.custom.js', __FILE__), false, '2.7.0', true );
}
//add_action('wp_enqueue_scripts', 'wpb_wps_modernizr');


/* ==========================================================================
   Enqueue js files
   ========================================================================== */

function wpb_wps_adding_scripts() {
	wp_enqueue_script( 'wpb-wps-toucheffects', plugins_url('../js/toucheffects.js', __FILE__), '', '1.0', true );
	wp_enqueue_script( 'wpb-wps-owl-carousel', plugins_url('../js/owl.carousel.js', __FILE__), array('jquery'), '1.3.2', false );
	wp_enqueue_script('wpb-wps-plugin-main', plugins_url('../js/plugin-main.js', __FILE__), array('jquery'), '1.0', true);
}
add_action( 'wp_enqueue_scripts', 'wpb_wps_adding_scripts' ); 



/* ==========================================================================
   Enqueue CSS files
   ========================================================================== */

function wpb_wps_adding_style() {

	$wpb_wps_load_font_awesome = wpb_wps_get_option( 'wpb_wps_load_font_awesome', 'wpb_wps_style_settings', 'on' );

	wp_enqueue_style( 'wpb_wrps_google_fonts', '//fonts.googleapis.com/css?family=Roboto+Condensed', false );
	wp_enqueue_style('wpb_wps_owl_carousel', plugins_url('../css/owl.carousel.css', __FILE__ ), '', '1.3.2', false);
	wp_enqueue_style( 'wpb_wps_main_style', plugins_url('../css/main.css', __FILE__), '', '1.0', false);
	if( $wpb_wps_load_font_awesome == 'on' ){
		wp_enqueue_style( 'wpb_wps_font_awesome', plugins_url('../css/font-awesome.min.css', __FILE__), '', '1.0', false);
	}
}
add_action( 'wp_enqueue_scripts', 'wpb_wps_adding_style', 11 );



/* ==========================================================================
   Enqueue CSS for admin
   ========================================================================== */

function wpb_wps_adding_style_admin() {
	wp_enqueue_style('wpb_wps_admin_style', plugins_url('../css/wpb-admin.css', __FILE__),'','1.0', false);
	wp_enqueue_script( 'wpb_wps_admin_script', plugins_url('../js/admin-script.js', __FILE__), array('jquery'), '1.0', false );
}
add_action( 'admin_enqueue_scripts', 'wpb_wps_adding_style_admin' );

